import { RecordProxy, Variables } from 'relay-runtime';
import { HandleFieldPayload, ReadOnlyRecordProxy, RecordSourceProxy } from 'relay-runtime/lib/store/RelayStoreTypes';
declare function update(store: RecordSourceProxy, payload: HandleFieldPayload): void;
declare function getConnections(record: ReadOnlyRecordProxy, key: string, filter?: (variables: Variables) => boolean): Array<RecordProxy>;
declare const _default: {
    update: typeof update;
    getConnections: typeof getConnections;
    buildConnectionEdge(store: RecordSourceProxy, connection: RecordProxy<{}>, edge: RecordProxy<{}> | null | undefined): RecordProxy<{}> | null | undefined;
    createEdge(store: RecordSourceProxy, record: RecordProxy<{}>, node: RecordProxy<{}>, edgeType: string): RecordProxy<{}>;
    deleteNode(record: RecordProxy<{}>, nodeID: string): void;
    getConnection(record: ReadOnlyRecordProxy, key: string, filters?: Variables | null | undefined): RecordProxy<{}> | null | undefined;
    insertEdgeAfter(record: RecordProxy<{}>, newEdge: RecordProxy<{}>, cursor?: string | null | undefined): void;
    insertEdgeBefore(record: RecordProxy<{}>, newEdge: RecordProxy<{}>, cursor?: string | null | undefined): void;
};
export default _default;
